# -*- coding: utf-8 -*-
from CommonRequest import obtain_server_data

# 数据结构设计
# 将id_agent2，及公司名称id，作为哈希的组件
money_map={}
site_map={}
order_map={}

# 公司对应的收入   公司收入   平台收入
def company_money(dateTime,token):
    data={
     'req_param':{
         'condition':{
            'date__begin':dateTime,
            'date__end':dateTime,
            "id_agent":["3"],
         },
        "group":"id_agent2",
        'system_role':"1"
     },
     'task':5005,
     'task_num':21,
     'token':token
    }
    res=obtain_server_data('5005-21','jp_count_benefit',data)

    if res is not None:
        for item in res['result']:
            # key
            key=item['id_agent2']
            # 公司收入
            money=item['money']
            # 平台收入
            kpl_money=item['earning_producer']
            money_map[key]={
                'money':money,'kpl_money':kpl_money
            }
            print(money,kpl_money)
        return money_map
    else :
        return {}


# 公司对应的设备 设备数 绑定设备 
def company_site(dateTime,token):
    data={
     'req_param':{
         'condition':{
            'date__begin':dateTime,
            'date__end':dateTime,
            "id_agent":["3"],
         },
        "group":"id_agent2",
        'system_role':"1"
     },
     'task':5003,
     'task_num':31,
     'token':token
    }
    res=obtain_server_data('5003-31','jp_query_car_coun',data)
    if res is not None:
        for item in res['result']:
            # key
            key=item['id_agent2']
            # 设备数
            siteCount=item['count']
            # 绑定设备
            bindCount=item['count_bind_coach']
            site_map[key]={
               'siteCount': siteCount,'bindCount':bindCount
            }
        return site_map
    else :
        return {}


# 公司订单统计
def company_order(dateTime,token):
    data={
     'req_param':{
         'condition':{
            'date__begin':dateTime,
            'date__end':dateTime,
            "id_agent":["3"],
         },
        'begin':'0',
        "limit":"9999999",
        'system_role':"1"
     },
     'task':5005,
     'task_num':13,
     'token':token
    }
    res=obtain_server_data('5005-13','jp_count_benefit',data)
    if res is not None:
        for item in res['result']:
            # key
            key=item['id_agent2']
            # 设备id
            sn=item['sn']
            # 支付状态 1 已完成  4 代缴费
            paystate= item['state']
            # 产生的费用
            money_cost=item['money_cost']
            # 计费时长 
            time_cost=item['time_cost']
            if key not in order_map:
                order_map[key]={
                    'sn':[],
                    '1':[],
                    '4':[],
                    'time_cost1':[],
                    'time_cost4':[],
                }

            # 去重可得在线车辆数
            order_map[key]['sn'].append(sn)
            # 订单总金额
            order_map[key][paystate].append(money_cost)
            # 计费时长
            order_map[key]['time_cost'+paystate].append(time_cost)
        return order_map
    else :
        return {}    


# 用户信息统计
def user_statistics(token):
    data={
     'req_param':{
     },
     'task':1002,
     'task_num':103,
     'token':token
    }
    res=obtain_server_data('5005-13','jp_count_benefit',data)
    if res is not None:
        # 本月新增教练数
        coach_month=res["coach_month"]
        # 今日新增教练数
        coach_today=res["coach_today"]
        # 教练总数
        coach_total=res["coach_total"]
        # 本月新增学员数	
        stu_month=res["stu_month"]
        # 今日新增学员数
        stu_today=res["stu_today"]
        # 学员总数
        stu_total=res["stu_total"]
        return {
            'coach_month':coach_month,
            'coach_today':coach_today,
            'coach_total':coach_total,
            'stu_month':stu_month,
            'stu_today':stu_today,
            'stu_total':stu_total
        }
    else:
        return {}    


# 收入统计 不能统计当天 只能统计昨天的数据
def income_statistics(dateTime,token):
    data={
     'req_param':{
        'date_begin':dateTime,
        'dete_end':dateTime,
        "group":"day",
     },
     'task':8002,
     'task_num':5,
     'token':token
    }
    res=obtain_server_data('8002-5','j2_query_count_info_detail',data)
    if res is not None:
        item=res['results'][0]["detail"]
        # 当日总流水	
        total_money= f'{round(int(item["total_money"])/100,2)}'
        # 当日平台总收入
        total_KPL_money= f'{round(int(item["producer_earning"])/100,2)}'
        # 当日训练总次数
        count=item["count"]
        # 当日训练总时长
        time=f'{round(int(item["time"])/3600,2)}'
         #当日训练总里程
        distance=f'{round(int(item["distance"])/1000,2)}'
        return {
            total_money,total_KPL_money,count,time,distance
        }
            
    else:    
        return {}